<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <div class="query-box">
        <div class="query-box__left">
          <el-form-item label="" prop="name">
            <el-input
              v-model="queryParams.name"
              placeholder="请输入别名"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item>
            <el-button
              type="primary"
              icon="el-icon-search"
              size="mini"
              @click="handleQuery"
              >搜索</el-button
            >
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
              >重置</el-button
            >
            <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
              v-hasPermi="['drugs:alias:add']"
              >新增</el-button>
              <el-button
                type="danger"
                plain
                icon="el-icon-delete"
                size="mini"
                :disabled="multiple"
                @click="handleDelete"
                v-hasPermi="['drugs:alias:remove']"
                >批量删除</el-button>
          </el-form-item>
        </div>
      </div>
    </el-form>

    <el-table
      v-loading="loading"
      :data="aliasList"
      @selection-change="handleSelectionChange"
      border
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" align="center" width="55" label="序号" />
      <el-table-column label="别名" align="center" prop="name" />
      <el-table-column label="拼音码" align="center" prop="params.pyq">
        <template slot-scope="scope">{{ scope.row.params.pyq }}</template>
      </el-table-column>

      <el-table-column label="五笔码" align="center" prop="params.wb">
        <template slot-scope="scope">{{ scope.row.params.wb }}</template>
      </el-table-column>
      <!-- <el-table-column label="药品规格名称" align="center" prop="specsName" /> -->
      <!-- <el-table-column label="类型：1药品2规格" align="center" prop="type" /> -->
      <!-- <el-table-column label="状态" align="center" prop="state">
        <template slot-scope="scope">
          <dict-tag :options="stateOptions" :value="scope.row.state" />
        </template>
      </el-table-column> -->
      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <!-- <el-table-column label="状态" align="center" prop="updateBy" /> -->
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="primary"
            style="width: 40px"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['drugs:alias:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="primary"
            style="width: 40px"
            @click="handleDelete(scope.row)"
            v-hasPermi="['drugs:alias:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改别名维护对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="药品规格" prop="specsId">
          <!-- <el-input v-model="form.specsName" placeholder="请输入药品规格" /> -->
          <el-select
            v-model="form.specsId"
            placeholder="请选择药品规格"
            style="width: 100%"
            filterable
            remote
            :remote-method="remoteMethod"
            :loading="loading2"
          >
            <el-option
              v-for="(specs,i) in specsList"
              :key="i"
              :label="specs.drugsName"
              :value="specs.drugsId+'-'+specs.specsId"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="药品别名" prop="name">
          <el-input
            v-model="form.name"
            placeholder="请输入药品别名"
            @input="handleChangeName"
          />
        </el-form-item>
        <el-form-item
          label="拼音码"
          prop="params.pyq"
          v-if="form.params !== undefined"
        >
          <el-input v-model="form.params.pyq" disabled />
        </el-form-item>
        <el-form-item
          label="五笔码"
          prop="params.wb"
          v-if="form.params !== undefined"
        >
          <el-input v-model="form.params.wb" disabled />
        </el-form-item>

        <!-- <el-form-item label="类型：1药品2规格" prop="type">
          <el-select v-model="form.type" placeholder="请选择类型：1药品2规格">
            <el-option label="请选择字典生成" value="" />
          </el-select>
        </el-form-item>
        <el-form-item label="状态" prop="state">
          <el-select v-model="form.state" placeholder="请选择状态">
            <el-option
              v-for="dict in stateOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item> -->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listAlias,
  getAlias,
  delAlias,
  addAlias,
  updateAlias,
  exportAlias,
  getByName
} from "@/api/drugs/alias";
import { listSpecsAll } from "@/api/drugs/specs";
import { getInfo } from "@/api/medical/mechanism";
export default {
  name: "Alias",
  data() {
    return {
      specsList: [],
      // 遮罩层
      loading: true,
      loading2: false,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 别名维护表格数据
      aliasList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 状态字典
      stateOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        drugsId: null,
        specsId: null,
        type: null,
        state: null,
      },
      // 表单参数
      form: {
        params: {
          pyq: "",
          wb: "",
        },
      },
      // 表单校验
      rules: {
        specsId: [
          { required: true, message: "请输入药品规格", trigger: "blur" },
        ],
        name: [{ required: true, message: "请输入药品别名", trigger: "blur" }],
        type: [
          {
            required: true,
            message: "类型：1药品2规格不能为空",
            trigger: "change",
          },
        ],
        state: [{ required: true, message: "状态不能为空", trigger: "change" }],
        createBy: [
          { required: true, message: "状态不能为空", trigger: "blur" },
        ],
        updateBy: [
          { required: true, message: "状态不能为空", trigger: "blur" },
        ],
        createTime: [
          { required: true, message: "状态不能为空", trigger: "blur" },
        ],
        updateTime: [
          { required: true, message: "状态不能为空", trigger: "blur" },
        ],
      },
    };
  },
  created() {
    this.getList();
    this.getListAll();
    this.getDicts("sys_normal_disable").then((response) => {
      this.stateOptions = response.data;
    });
  },
  methods: {
    remoteMethod (name) {
      this.loading2 = true
      getByName({
        name
      }).then((res) => {
        this.specsList = res.data;
        this.loading2 = false
      })
    },
    /** 查询别名维护列表 */
    getList() {
      this.loading = true;
      listAlias(this.queryParams).then((response) => {
        this.aliasList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getListAll() {
      getByName({
        name: ''
      }).then((res) => {
        this.specsList = res.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        drugsId: null,
        specsId: null,
        type: null,
        state: null,
        createBy: null,
        updateBy: null,
        createTime: null,
        updateTime: null,
        specsName: "",
        params: {
          pyq: "",
          wb: "",
        },
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加别名维护";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getAlias(id).then((response) => {
        this.form = response.data;
        this.form.specsId = response.data.drugsId + '-' + response.data.specsId
        this.open = true;
        this.title = "修改别名维护";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        //console.log(this.form);
        if (valid) {
          var p = this.form.specsId.split('-')
          var drugsId = p[0]
          var specsId = p[1]
          if (this.form.id != null) {
            updateAlias({
              id: this.form.id,
              drugsId,
              specsId,
              name: this.form.name
            }).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addAlias({
              id: '',
              drugsId,
              specsId,
              name: this.form.name
            }).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm("确定需要删除已选数据吗？", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delAlias(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有别名维护数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.exportLoading = true;
          return exportAlias(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
          this.exportLoading = false;
        })
        .catch(() => {});
    },
    //通过别名获取五笔、拼音
    handleChangeName(e) {
      getInfo(e).then((res) => {
        if (res.code === 200) {
          this.$set(this.form.params, "pyq", res.data.pyq);
          this.$set(this.form.params, "wb", res.data.wb);
        }
      });
    },
  },
};
</script>
